import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.io.*;

public class Ja extends Frame implements ActionListener {

  private static int flg = 1;

  private Panel p, pv, pb;

  private Button Bstop, Brun, Bstep, Bquit;

  static String[] args;
  static int[] runflag = new int[1];

  private JacoGraph jgrph;
  // private MetroInputs minputs;

  public void init() {
    setFont(new Font("Helvetica", Font.PLAIN, 14));

    pb = new Panel();

    pb.setLayout(new GridLayout(10, 1));
    pb.setBackground(Color.orange);

    Brun = new Button("Run");
    Brun.addActionListener(this);
    pb.add(Brun);

    // Bstep = new Button("Step");
    // Bstep.addActionListener(this);
    // pb.add(Bstep);

    Bquit = new Button("Quit");
    Bquit.addActionListener(this);
    pb.add(Bquit);

    setLayout(new BorderLayout());
    jgrph = new JacoGraphics();
    add("Center",jgrph);
    add("West",pb);
  }

  public void actionPerformed(ActionEvent evt) {

    if(evt.getActionCommand() == "Run") 
      {
	runflag[0] = 1;
	// MPI.COMM_WORLD.Bcast(runflag,0,1,MPI.INT,0);
      }
    /* else     
       if(evt.getActionCommand() == "Step") 
	 {
	  System.out.println("proc is ### "+MPI.Get_processor_name());
	  //Init.input();     
	} */
      else     
	if(evt.getActionCommand() == "Quit") 
	  {
	    /* if(MPI.Initialized()) 
	      {
		runflag[0] = -99;
		//System.out.println("proc is ### "+MPI.Get_processor_name());
		MPI.COMM_WORLD.Bcast(runflag,0,1,MPI.INT,0);
	      }
	    else */  System.exit(1);	  
	  }
  }


  void update() {
    jgrph.repaint();
  }

  static public void main(String[] args) 
  {

    Ja tester = new Ja();
    
    // if(CommVars.procnum == 0) {
      tester.init();
      tester.setSize(1000, 700);
    // }


    while (true) 
      {
	/* if(CommVars.procnum != 0) 
	  MPI.COMM_WORLD.Bcast(runflag,0,1,MPI.INT,0); 
	
	
	MPI.COMM_WORLD.Barrier(); */
	//System.out.println("proc is**** "+MPI.Get_processor_name());
	
	
	/* if(runflag[0] == -99) {
	  MPI.Finalize();
	  System.exit(1);
	} */
	
	// Read in the parameters.    
	// Domain.decompose(); 

	tester.metstart();
      }  // end while
  }


  
  public void metstart() {
    int    i, start;
    long   seed;
    double starttime, endtime, time;
    

    // System.out.println("proc is "+MPI.Get_processor_name());

    // Initialize the random number generator.
    // Prand.randinit(); 
 
 
    // Initialize the spins.
    // Init.init_spins();
 
 
    // Initialize the data.
    // Measure.init();
  
    // Thermalize the system.
    metupdate(CommVars.therm_sweeps);
 
    // Jaolis update, taking measurements every 'sweeps' iterations.
 
    time = 0;
 
    for (i=0; i<CommVars.measurements; i++) {
      starttime = MPI.Wtime();
 
      metupdate(CommVars.sweeps);

      endtime = MPI.Wtime();
           
      time += (endtime - starttime);
      Measure.compute();
      if(CommVars.procnum == 0) 
      Measure.mid_output();
    }
 

    // Print out results 
    if(CommVars.procnum == 0) {
      Measure.final_output();
      System.out.println("\n\n Time is "+time+" seconds\n\n");
    }
 


//    if(CommVars.procnum != 0) {
//	CommVars.comm2d.Bcast(runflag,0,1,MPI.INT,0);
//    }
//
//    CommVars.comm2d.Barrier();
//    
//    if(runflag[0] == -99) {
//	MPI.Finalize();
//	System.exit(1);
//    }
// 
  }


  public void draw() 
  {  
    int root = 0,i, j;
    int local_size = CommVars.isiz * CommVars.jsiz;
    int global_size = CommVars.globisiz * CommVars.globjsiz;
    int tmp[] = new int[local_size];
    int globaltmp[] = new int[global_size];

   
    // copy 2D -> 1D; mpiJava can only send 1D array.
    for(i=1;i<CommVars.isiz+1;i++)
      for(j=1;j<CommVars.jsiz+1;j++)
	tmp[(i-1)*CommVars.jsiz+(j-1)] = CommVars.spin[i][j];

    //CommVars.comm2d.Gather(tmp,       0, local_size, MPI.INT,
    CommVars.comm2d.Gather(tmp,       0, local_size, MPI.INT,
			  globaltmp, 0, local_size, MPI.INT,
			  root);
    
    
    if(CommVars.procnum==0) {
      for(i=0;i<CommVars.globisiz;i++)
	for(j=0;j<CommVars.globjsiz;j++)
	  CommVars.global_spin[i][j] = globaltmp[i*CommVars.jsiz+j] ;
      // draw the picture      
      jgrph.repaint();
    }

  }


/*--------------------------------------------------------------------
                                                                      
                                                                      
    Jaolis Monte Carlo update of the Ising model.                 
                                                                      
    For the Ising model new_spin = - old_spin, so                     
    the old energy   oldE = - old_spin * (sum of neighboring spins)   
    the new energy   newE = - new_spin * (sum of neighboring spins)   
                          = - oldE                                    
                                                                      
    Do black/white checkerboard update, so can pass edge values       
    (blocked data) which will be more efficient than passing          
    single spins at a time (unblocked data).                          
                                                                      
----------------------------------------------------------------------*/

  public void metupdate(int iterations) {
    int black_white;
    int n, i, j;
    int new_spin, old_spin;
    int new_energy,old_energy, diff;
    int spin1, spin2, spin3, spin4;
    double randnum;
    
	
    for (n=0; n<iterations; n++) {

      CommVars.ACCEPT = 0;
      //Edges.all_edges(CommVars);	
      for (i=1; i<=CommVars.isiz; i++) {
	for (j=1; j<=CommVars.jsiz; j++) {
	  
	  old_spin = CommVars.spin[i][j];
	  
	  // Pick a new random trial spin
	  //if(CommVars.Q == 2) 
	  //new_spin = 1 - old_spin;         /* only for Q=2 */
	  //else {
	    new_spin = (int) ( Prand.rand() * (CommVars.Q-1)) + 1;
	    new_spin = (old_spin + new_spin) % CommVars.Q;
	    //}

	  spin1 = Edges.get_spin(i-1, j);
	  spin2 = Edges.get_spin(i+1, j);
	  spin3 = Edges.get_spin(i,   j-1);
	  spin4 = Edges.get_spin(i,   j+1);
	  
	  old_energy = 0;
	  new_energy = 0;

	  if(old_spin == spin1) old_energy++;
	  if(old_spin == spin2) old_energy++;
	  if(old_spin == spin3) old_energy++;
	  if(old_spin == spin4) old_energy++;
	  
	  if(new_spin == spin1) new_energy++;
	  if(new_spin == spin2) new_energy++;
	  if(new_spin == spin3) new_energy++;
	  if(new_spin == spin4) new_energy++;

	  diff = old_energy - new_energy;
	  // reversed due to - sign in energy
	
	  if ((diff<=0) ||  Math.exp(-CommVars.beta*diff) > Prand.rand() ) {
	    CommVars.ACCEPT++;
	    CommVars.spin[i][j] = new_spin;
	  }

	  if(CommVars.updateflag == 2) 
	    { CommVars.comm2d.Barrier();  draw();}

	}
	if(CommVars.updateflag == 1) 
	  { CommVars.comm2d.Barrier();  draw();}
      } //  End of loop over sites
      if(CommVars.updateflag == 0) 
	{ CommVars.comm2d.Barrier();  draw();}
    } // End of loop over sweeps

    // Pass edges to neighboring processors.  
    Edges.spin_edges();    

  }  
    

}





